<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/anyhow-1.0.58/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../anyhow/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../anyhow/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../anyhow/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
<span id="494">494</span>
<span id="495">495</span>
<span id="496">496</span>
<span id="497">497</span>
<span id="498">498</span>
<span id="499">499</span>
<span id="500">500</span>
<span id="501">501</span>
<span id="502">502</span>
<span id="503">503</span>
<span id="504">504</span>
<span id="505">505</span>
<span id="506">506</span>
<span id="507">507</span>
<span id="508">508</span>
<span id="509">509</span>
<span id="510">510</span>
<span id="511">511</span>
<span id="512">512</span>
<span id="513">513</span>
<span id="514">514</span>
<span id="515">515</span>
<span id="516">516</span>
<span id="517">517</span>
<span id="518">518</span>
<span id="519">519</span>
<span id="520">520</span>
<span id="521">521</span>
<span id="522">522</span>
<span id="523">523</span>
<span id="524">524</span>
<span id="525">525</span>
<span id="526">526</span>
<span id="527">527</span>
<span id="528">528</span>
<span id="529">529</span>
<span id="530">530</span>
<span id="531">531</span>
<span id="532">532</span>
<span id="533">533</span>
<span id="534">534</span>
<span id="535">535</span>
<span id="536">536</span>
<span id="537">537</span>
<span id="538">538</span>
<span id="539">539</span>
<span id="540">540</span>
<span id="541">541</span>
<span id="542">542</span>
<span id="543">543</span>
<span id="544">544</span>
<span id="545">545</span>
<span id="546">546</span>
<span id="547">547</span>
<span id="548">548</span>
<span id="549">549</span>
<span id="550">550</span>
<span id="551">551</span>
<span id="552">552</span>
<span id="553">553</span>
<span id="554">554</span>
<span id="555">555</span>
<span id="556">556</span>
<span id="557">557</span>
<span id="558">558</span>
<span id="559">559</span>
<span id="560">560</span>
<span id="561">561</span>
<span id="562">562</span>
<span id="563">563</span>
<span id="564">564</span>
<span id="565">565</span>
<span id="566">566</span>
<span id="567">567</span>
<span id="568">568</span>
<span id="569">569</span>
<span id="570">570</span>
<span id="571">571</span>
<span id="572">572</span>
<span id="573">573</span>
<span id="574">574</span>
<span id="575">575</span>
<span id="576">576</span>
<span id="577">577</span>
<span id="578">578</span>
<span id="579">579</span>
<span id="580">580</span>
<span id="581">581</span>
<span id="582">582</span>
<span id="583">583</span>
<span id="584">584</span>
<span id="585">585</span>
<span id="586">586</span>
<span id="587">587</span>
<span id="588">588</span>
<span id="589">589</span>
<span id="590">590</span>
<span id="591">591</span>
<span id="592">592</span>
<span id="593">593</span>
<span id="594">594</span>
<span id="595">595</span>
<span id="596">596</span>
<span id="597">597</span>
<span id="598">598</span>
<span id="599">599</span>
<span id="600">600</span>
<span id="601">601</span>
<span id="602">602</span>
<span id="603">603</span>
<span id="604">604</span>
<span id="605">605</span>
<span id="606">606</span>
<span id="607">607</span>
<span id="608">608</span>
<span id="609">609</span>
<span id="610">610</span>
<span id="611">611</span>
<span id="612">612</span>
<span id="613">613</span>
<span id="614">614</span>
<span id="615">615</span>
<span id="616">616</span>
<span id="617">617</span>
<span id="618">618</span>
<span id="619">619</span>
<span id="620">620</span>
<span id="621">621</span>
<span id="622">622</span>
<span id="623">623</span>
<span id="624">624</span>
<span id="625">625</span>
<span id="626">626</span>
<span id="627">627</span>
<span id="628">628</span>
<span id="629">629</span>
<span id="630">630</span>
<span id="631">631</span>
<span id="632">632</span>
<span id="633">633</span>
<span id="634">634</span>
<span id="635">635</span>
<span id="636">636</span>
<span id="637">637</span>
<span id="638">638</span>
<span id="639">639</span>
<span id="640">640</span>
<span id="641">641</span>
<span id="642">642</span>
<span id="643">643</span>
<span id="644">644</span>
<span id="645">645</span>
<span id="646">646</span>
<span id="647">647</span>
<span id="648">648</span>
<span id="649">649</span>
<span id="650">650</span>
<span id="651">651</span>
<span id="652">652</span>
<span id="653">653</span>
<span id="654">654</span>
<span id="655">655</span>
<span id="656">656</span>
<span id="657">657</span>
<span id="658">658</span>
<span id="659">659</span>
<span id="660">660</span>
<span id="661">661</span>
<span id="662">662</span>
<span id="663">663</span>
<span id="664">664</span>
<span id="665">665</span>
<span id="666">666</span>
<span id="667">667</span>
<span id="668">668</span>
<span id="669">669</span>
<span id="670">670</span>
<span id="671">671</span>
<span id="672">672</span>
<span id="673">673</span>
<span id="674">674</span>
<span id="675">675</span>
<span id="676">676</span>
<span id="677">677</span>
<span id="678">678</span>
<span id="679">679</span>
</pre><pre class="rust"><code><span class="doccomment">//! [![github]](https://github.com/dtolnay/anyhow)&amp;ensp;[![crates-io]](https://crates.io/crates/anyhow)&amp;ensp;[![docs-rs]](https://docs.rs/anyhow)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [github]: https://img.shields.io/badge/github-8da0cb?style=for-the-badge&amp;labelColor=555555&amp;logo=github</span>
<span class="doccomment">//! [crates-io]: https://img.shields.io/badge/crates.io-fc8d62?style=for-the-badge&amp;labelColor=555555&amp;logo=rust</span>
<span class="doccomment">//! [docs-rs]: https://img.shields.io/badge/docs.rs-66c2a5?style=for-the-badge&amp;labelColor=555555&amp;logo=docs.rs</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! &lt;br&gt;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This library provides [`anyhow::Error`][Error], a trait object based error</span>
<span class="doccomment">//! type for easy idiomatic error handling in Rust applications.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! &lt;br&gt;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Details</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - Use `Result&lt;T, anyhow::Error&gt;`, or equivalently `anyhow::Result&lt;T&gt;`, as</span>
<span class="doccomment">//!   the return type of any fallible function.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   Within the function, use `?` to easily propagate any error that implements</span>
<span class="doccomment">//!   the `std::error::Error` trait.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!   # pub trait Deserialize {}</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # mod serde_json {</span>
<span class="doccomment">//!   #     use super::Deserialize;</span>
<span class="doccomment">//!   #     use std::io;</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   #     pub fn from_str&lt;T: Deserialize&gt;(json: &amp;str) -&gt; io::Result&lt;T&gt; {</span>
<span class="doccomment">//!   #         unimplemented!()</span>
<span class="doccomment">//!   #     }</span>
<span class="doccomment">//!   # }</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # struct ClusterMap;</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # impl Deserialize for ClusterMap {}</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   use anyhow::Result;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   fn get_cluster_info() -&gt; Result&lt;ClusterMap&gt; {</span>
<span class="doccomment">//!       let config = std::fs::read_to_string(&quot;cluster.json&quot;)?;</span>
<span class="doccomment">//!       let map: ClusterMap = serde_json::from_str(&amp;config)?;</span>
<span class="doccomment">//!       Ok(map)</span>
<span class="doccomment">//!   }</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # fn main() {}</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - Attach context to help the person troubleshooting the error understand</span>
<span class="doccomment">//!   where things went wrong. A low-level error like &quot;No such file or</span>
<span class="doccomment">//!   directory&quot; can be annoying to debug without more context about what higher</span>
<span class="doccomment">//!   level step the application was in the middle of.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!   # struct It;</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # impl It {</span>
<span class="doccomment">//!   #     fn detach(&amp;self) -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">//!   #         unimplemented!()</span>
<span class="doccomment">//!   #     }</span>
<span class="doccomment">//!   # }</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   use anyhow::{Context, Result};</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   fn main() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">//!       # return Ok(());</span>
<span class="doccomment">//!       #</span>
<span class="doccomment">//!       # const _: &amp;str = stringify! {</span>
<span class="doccomment">//!       ...</span>
<span class="doccomment">//!       # };</span>
<span class="doccomment">//!       #</span>
<span class="doccomment">//!       # let it = It;</span>
<span class="doccomment">//!       # let path = &quot;./path/to/instrs.json&quot;;</span>
<span class="doccomment">//!       #</span>
<span class="doccomment">//!       it.detach().context(&quot;Failed to detach the important thing&quot;)?;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!       let content = std::fs::read(path)</span>
<span class="doccomment">//!           .with_context(|| format!(&quot;Failed to read instrs from {}&quot;, path))?;</span>
<span class="doccomment">//!       #</span>
<span class="doccomment">//!       # const _: &amp;str = stringify! {</span>
<span class="doccomment">//!       ...</span>
<span class="doccomment">//!       # };</span>
<span class="doccomment">//!       #</span>
<span class="doccomment">//!       # Ok(())</span>
<span class="doccomment">//!   }</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   ```console</span>
<span class="doccomment">//!   Error: Failed to read instrs from ./path/to/instrs.json</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   Caused by:</span>
<span class="doccomment">//!       No such file or directory (os error 2)</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - Downcasting is supported and can be by value, by shared reference, or by</span>
<span class="doccomment">//!   mutable reference as needed.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!   # use anyhow::anyhow;</span>
<span class="doccomment">//!   # use std::fmt::{self, Display};</span>
<span class="doccomment">//!   # use std::task::Poll;</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # #[derive(Debug)]</span>
<span class="doccomment">//!   # enum DataStoreError {</span>
<span class="doccomment">//!   #     Censored(()),</span>
<span class="doccomment">//!   # }</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # impl Display for DataStoreError {</span>
<span class="doccomment">//!   #     fn fmt(&amp;self, formatter: &amp;mut fmt::Formatter) -&gt; fmt::Result {</span>
<span class="doccomment">//!   #         unimplemented!()</span>
<span class="doccomment">//!   #     }</span>
<span class="doccomment">//!   # }</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # impl std::error::Error for DataStoreError {}</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # const REDACTED_CONTENT: () = ();</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # let error = anyhow!(&quot;...&quot;);</span>
<span class="doccomment">//!   # let root_cause = &amp;error;</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # let ret =</span>
<span class="doccomment">//!   // If the error was caused by redaction, then return a</span>
<span class="doccomment">//!   // tombstone instead of the content.</span>
<span class="doccomment">//!   match root_cause.downcast_ref::&lt;DataStoreError&gt;() {</span>
<span class="doccomment">//!       Some(DataStoreError::Censored(_)) =&gt; Ok(Poll::Ready(REDACTED_CONTENT)),</span>
<span class="doccomment">//!       None =&gt; Err(error),</span>
<span class="doccomment">//!   }</span>
<span class="doccomment">//!   # ;</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - If using the nightly channel, or stable with `features = [&quot;backtrace&quot;]`, a</span>
<span class="doccomment">//!   backtrace is captured and printed with the error if the underlying error</span>
<span class="doccomment">//!   type does not already provide its own. In order to see backtraces, they</span>
<span class="doccomment">//!   must be enabled through the environment variables described in</span>
<span class="doccomment">//!   [`std::backtrace`]:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   - If you want panics and errors to both have backtraces, set</span>
<span class="doccomment">//!     `RUST_BACKTRACE=1`;</span>
<span class="doccomment">//!   - If you want only errors to have backtraces, set `RUST_LIB_BACKTRACE=1`;</span>
<span class="doccomment">//!   - If you want only panics to have backtraces, set `RUST_BACKTRACE=1` and</span>
<span class="doccomment">//!     `RUST_LIB_BACKTRACE=0`.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   The tracking issue for this feature is [rust-lang/rust#53487].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   [`std::backtrace`]: https://doc.rust-lang.org/std/backtrace/index.html#environment-variables</span>
<span class="doccomment">//!   [rust-lang/rust#53487]: https://github.com/rust-lang/rust/issues/53487</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - Anyhow works with any error type that has an impl of `std::error::Error`,</span>
<span class="doccomment">//!   including ones defined in your crate. We do not bundle a `derive(Error)`</span>
<span class="doccomment">//!   macro but you can write the impls yourself or use a standalone macro like</span>
<span class="doccomment">//!   [thiserror].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   [thiserror]: https://github.com/dtolnay/thiserror</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!   use thiserror::Error;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   #[derive(Error, Debug)]</span>
<span class="doccomment">//!   pub enum FormatError {</span>
<span class="doccomment">//!       #[error(&quot;Invalid header (expected {expected:?}, got {found:?})&quot;)]</span>
<span class="doccomment">//!       InvalidHeader {</span>
<span class="doccomment">//!           expected: String,</span>
<span class="doccomment">//!           found: String,</span>
<span class="doccomment">//!       },</span>
<span class="doccomment">//!       #[error(&quot;Missing attribute: {0}&quot;)]</span>
<span class="doccomment">//!       MissingAttribute(String),</span>
<span class="doccomment">//!   }</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - One-off error messages can be constructed using the `anyhow!` macro, which</span>
<span class="doccomment">//!   supports string interpolation and produces an `anyhow::Error`.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!   # use anyhow::{anyhow, Result};</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # fn demo() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">//!   #     let missing = &quot;...&quot;;</span>
<span class="doccomment">//!   return Err(anyhow!(&quot;Missing attribute: {}&quot;, missing));</span>
<span class="doccomment">//!   #     Ok(())</span>
<span class="doccomment">//!   # }</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   A `bail!` macro is provided as a shorthand for the same early return.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!   # use anyhow::{bail, Result};</span>
<span class="doccomment">//!   #</span>
<span class="doccomment">//!   # fn demo() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">//!   #     let missing = &quot;...&quot;;</span>
<span class="doccomment">//!   bail!(&quot;Missing attribute: {}&quot;, missing);</span>
<span class="doccomment">//!   #     Ok(())</span>
<span class="doccomment">//!   # }</span>
<span class="doccomment">//!   ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! &lt;br&gt;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # No-std support</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! In no_std mode, the same API is almost all available and works the same way.</span>
<span class="doccomment">//! To depend on Anyhow in no_std mode, disable our default enabled &quot;std&quot;</span>
<span class="doccomment">//! feature in Cargo.toml. A global allocator is required.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```toml</span>
<span class="doccomment">//! [dependencies]</span>
<span class="doccomment">//! anyhow = { version = &quot;1.0&quot;, default-features = false }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Since the `?`-based error conversions would normally rely on the</span>
<span class="doccomment">//! `std::error::Error` trait which is only available through std, no_std mode</span>
<span class="doccomment">//! will require an explicit `.map_err(Error::msg)` when working with a</span>
<span class="doccomment">//! non-Anyhow error type inside a function that returns Anyhow&#39;s error type.</span>

<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/anyhow/1.0.58&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">backtrace</span>, <span class="ident">feature</span>(<span class="ident">backtrace</span>))]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">feature</span>(<span class="ident">doc_cfg</span>))]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>), <span class="ident">no_std</span>)]</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">dead_code</span>, <span class="ident">unused_imports</span>, <span class="ident">unused_mut</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(
    <span class="ident">clippy::doc_markdown</span>,
    <span class="ident">clippy::enum_glob_use</span>,
    <span class="ident">clippy::missing_errors_doc</span>,
    <span class="ident">clippy::missing_panics_doc</span>,
    <span class="ident">clippy::module_name_repetitions</span>,
    <span class="ident">clippy::must_use_candidate</span>,
    <span class="ident">clippy::needless_doctest_main</span>,
    <span class="ident">clippy::new_ret_no_self</span>,
    <span class="ident">clippy::redundant_else</span>,
    <span class="ident">clippy::return_self_not_must_use</span>,
    <span class="ident">clippy::unused_self</span>,
    <span class="ident">clippy::used_underscore_binding</span>,
    <span class="ident">clippy::wildcard_imports</span>,
    <span class="ident">clippy::wrong_self_convention</span>
)]</span>

<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">alloc</span>;

<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">mod</span> <span class="ident">backtrace</span>;
<span class="kw">mod</span> <span class="ident">chain</span>;
<span class="kw">mod</span> <span class="ident">context</span>;
<span class="kw">mod</span> <span class="ident">ensure</span>;
<span class="kw">mod</span> <span class="ident">error</span>;
<span class="kw">mod</span> <span class="ident">fmt</span>;
<span class="kw">mod</span> <span class="ident">kind</span>;
<span class="kw">mod</span> <span class="ident">macros</span>;
<span class="kw">mod</span> <span class="ident">ptr</span>;
<span class="kw">mod</span> <span class="ident">wrapper</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::error::ErrorImpl</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::ptr::Own</span>;
<span class="kw">use</span> <span class="ident">core::fmt::Display</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">use</span> <span class="ident">core::fmt::Debug</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">std::error::Error</span> <span class="kw">as</span> <span class="ident">StdError</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">trait</span> <span class="ident">StdError</span>: <span class="ident">Debug</span> <span class="op">+</span> <span class="ident">Display</span> {
    <span class="kw">fn</span> <span class="ident">source</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>(<span class="kw">dyn</span> <span class="ident">StdError</span> <span class="op">+</span> <span class="lifetime">&#39;static</span>)<span class="op">&gt;</span> {
        <span class="prelude-val">None</span>
    }
}

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">anyhow</span> <span class="kw">as</span> <span class="ident">format_err</span>;

<span class="doccomment">/// The `Error` type, a wrapper around a dynamic error type.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// `Error` works a lot like `Box&lt;dyn std::error::Error&gt;`, but with these</span>
<span class="doccomment">/// differences:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// - `Error` requires that the error is `Send`, `Sync`, and `&#39;static`.</span>
<span class="doccomment">/// - `Error` guarantees that a backtrace is available, even if the underlying</span>
<span class="doccomment">///   error type does not provide one.</span>
<span class="doccomment">/// - `Error` is represented as a narrow pointer &amp;mdash; exactly one word in</span>
<span class="doccomment">///   size instead of two.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// &lt;br&gt;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Display representations</span>
<span class="doccomment">///</span>
<span class="doccomment">/// When you print an error object using &quot;{}&quot; or to_string(), only the outermost</span>
<span class="doccomment">/// underlying error or context is printed, not any of the lower level causes.</span>
<span class="doccomment">/// This is exactly as if you had called the Display impl of the error from</span>
<span class="doccomment">/// which you constructed your anyhow::Error.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```console</span>
<span class="doccomment">/// Failed to read instrs from ./path/to/instrs.json</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// To print causes as well using anyhow&#39;s default formatting of causes, use the</span>
<span class="doccomment">/// alternate selector &quot;{:#}&quot;.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```console</span>
<span class="doccomment">/// Failed to read instrs from ./path/to/instrs.json: No such file or directory (os error 2)</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The Debug format &quot;{:?}&quot; includes your backtrace if one was captured. Note</span>
<span class="doccomment">/// that this is the representation you get by default if you return an error</span>
<span class="doccomment">/// from `fn main` instead of printing it explicitly yourself.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```console</span>
<span class="doccomment">/// Error: Failed to read instrs from ./path/to/instrs.json</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Caused by:</span>
<span class="doccomment">///     No such file or directory (os error 2)</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// and if there is a backtrace available:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```console</span>
<span class="doccomment">/// Error: Failed to read instrs from ./path/to/instrs.json</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Caused by:</span>
<span class="doccomment">///     No such file or directory (os error 2)</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Stack backtrace:</span>
<span class="doccomment">///    0: &lt;E as anyhow::context::ext::StdError&gt;::ext_context</span>
<span class="doccomment">///              at /git/anyhow/src/backtrace.rs:26</span>
<span class="doccomment">///    1: core::result::Result&lt;T,E&gt;::map_err</span>
<span class="doccomment">///              at /git/rustc/src/libcore/result.rs:596</span>
<span class="doccomment">///    2: anyhow::context::&lt;impl anyhow::Context&lt;T,E&gt; for core::result::Result&lt;T,E&gt;&gt;::with_context</span>
<span class="doccomment">///              at /git/anyhow/src/context.rs:58</span>
<span class="doccomment">///    3: testing::main</span>
<span class="doccomment">///              at src/main.rs:5</span>
<span class="doccomment">///    4: std::rt::lang_start</span>
<span class="doccomment">///              at /git/rustc/src/libstd/rt.rs:61</span>
<span class="doccomment">///    5: main</span>
<span class="doccomment">///    6: __libc_start_main</span>
<span class="doccomment">///    7: _start</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// To see a conventional struct-style Debug representation, use &quot;{:#?}&quot;.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```console</span>
<span class="doccomment">/// Error {</span>
<span class="doccomment">///     context: &quot;Failed to read instrs from ./path/to/instrs.json&quot;,</span>
<span class="doccomment">///     source: Os {</span>
<span class="doccomment">///         code: 2,</span>
<span class="doccomment">///         kind: NotFound,</span>
<span class="doccomment">///         message: &quot;No such file or directory&quot;,</span>
<span class="doccomment">///     },</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// If none of the built-in representations are appropriate and you would prefer</span>
<span class="doccomment">/// to render the error and its cause chain yourself, it can be done something</span>
<span class="doccomment">/// like this:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use anyhow::{Context, Result};</span>
<span class="doccomment">///</span>
<span class="doccomment">/// fn main() {</span>
<span class="doccomment">///     if let Err(err) = try_main() {</span>
<span class="doccomment">///         eprintln!(&quot;ERROR: {}&quot;, err);</span>
<span class="doccomment">///         err.chain().skip(1).for_each(|cause| eprintln!(&quot;because: {}&quot;, cause));</span>
<span class="doccomment">///         std::process::exit(1);</span>
<span class="doccomment">///     }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// fn try_main() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">///     # const IGNORE: &amp;str = stringify! {</span>
<span class="doccomment">///     ...</span>
<span class="doccomment">///     # };</span>
<span class="doccomment">///     # Ok(())</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">transparent</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Error</span> {
    <span class="ident">inner</span>: <span class="ident">Own</span><span class="op">&lt;</span><span class="ident">ErrorImpl</span><span class="op">&gt;</span>,
}

<span class="doccomment">/// Iterator of a chain of source errors.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This type is the iterator returned by [`Error::chain`].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use anyhow::Error;</span>
<span class="doccomment">/// use std::io;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// pub fn underlying_io_error_kind(error: &amp;Error) -&gt; Option&lt;io::ErrorKind&gt; {</span>
<span class="doccomment">///     for cause in error.chain() {</span>
<span class="doccomment">///         if let Some(io_error) = cause.downcast_ref::&lt;io::Error&gt;() {</span>
<span class="doccomment">///             return Some(io_error.kind());</span>
<span class="doccomment">///         }</span>
<span class="doccomment">///     }</span>
<span class="doccomment">///     None</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)))]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Chain</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">state</span>: <span class="ident"><span class="kw">crate</span>::chain::ChainState</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>,
}

<span class="doccomment">/// `Result&lt;T, Error&gt;`</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is a reasonable return type to use throughout your application but also</span>
<span class="doccomment">/// for `fn main`; if you do, failures will be printed along with any</span>
<span class="doccomment">/// [context][Context] and a backtrace if one was captured.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// `anyhow::Result` may be used with one *or* two type parameters.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```rust</span>
<span class="doccomment">/// use anyhow::Result;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # const IGNORE: &amp;str = stringify! {</span>
<span class="doccomment">/// fn demo1() -&gt; Result&lt;T&gt; {...}</span>
<span class="doccomment">///            // ^ equivalent to std::result::Result&lt;T, anyhow::Error&gt;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// fn demo2() -&gt; Result&lt;T, OtherError&gt; {...}</span>
<span class="doccomment">///            // ^ equivalent to std::result::Result&lt;T, OtherError&gt;</span>
<span class="doccomment">/// # };</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # pub trait Deserialize {}</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// # mod serde_json {</span>
<span class="doccomment">/// #     use super::Deserialize;</span>
<span class="doccomment">/// #     use std::io;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// #     pub fn from_str&lt;T: Deserialize&gt;(json: &amp;str) -&gt; io::Result&lt;T&gt; {</span>
<span class="doccomment">/// #         unimplemented!()</span>
<span class="doccomment">/// #     }</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// # #[derive(Debug)]</span>
<span class="doccomment">/// # struct ClusterMap;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// # impl Deserialize for ClusterMap {}</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// use anyhow::Result;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// fn main() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">///     # return Ok(());</span>
<span class="doccomment">///     let config = std::fs::read_to_string(&quot;cluster.json&quot;)?;</span>
<span class="doccomment">///     let map: ClusterMap = serde_json::from_str(&amp;config)?;</span>
<span class="doccomment">///     println!(&quot;cluster info: {:#?}&quot;, map);</span>
<span class="doccomment">///     Ok(())</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">E</span> <span class="op">=</span> <span class="ident">Error</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">core::result::Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">E</span><span class="op">&gt;</span>;

<span class="doccomment">/// Provides the `context` method for `Result`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This trait is sealed and cannot be implemented for types outside of</span>
<span class="doccomment">/// `anyhow`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// &lt;br&gt;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use anyhow::{Context, Result};</span>
<span class="doccomment">/// use std::fs;</span>
<span class="doccomment">/// use std::path::PathBuf;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// pub struct ImportantThing {</span>
<span class="doccomment">///     path: PathBuf,</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// impl ImportantThing {</span>
<span class="doccomment">///     # const IGNORE: &amp;&#39;static str = stringify! {</span>
<span class="doccomment">///     pub fn detach(&amp;mut self) -&gt; Result&lt;()&gt; {...}</span>
<span class="doccomment">///     # };</span>
<span class="doccomment">///     # fn detach(&amp;mut self) -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">///     #     unimplemented!()</span>
<span class="doccomment">///     # }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// pub fn do_it(mut it: ImportantThing) -&gt; Result&lt;Vec&lt;u8&gt;&gt; {</span>
<span class="doccomment">///     it.detach().context(&quot;Failed to detach the important thing&quot;)?;</span>
<span class="doccomment">///</span>
<span class="doccomment">///     let path = &amp;it.path;</span>
<span class="doccomment">///     let content = fs::read(path)</span>
<span class="doccomment">///         .with_context(|| format!(&quot;Failed to read instrs from {}&quot;, path.display()))?;</span>
<span class="doccomment">///</span>
<span class="doccomment">///     Ok(content)</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// When printed, the outermost context would be printed first and the lower</span>
<span class="doccomment">/// level underlying causes would be enumerated below.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```console</span>
<span class="doccomment">/// Error: Failed to read instrs from ./path/to/instrs.json</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Caused by:</span>
<span class="doccomment">///     No such file or directory (os error 2)</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Refer to the [Display representations] documentation for other forms in</span>
<span class="doccomment">/// which this context chain can be rendered.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [Display representations]: Error#display-representations</span>
<span class="doccomment">///</span>
<span class="doccomment">/// &lt;br&gt;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Effect on downcasting</span>
<span class="doccomment">///</span>
<span class="doccomment">/// After attaching context of type `C` onto an error of type `E`, the resulting</span>
<span class="doccomment">/// `anyhow::Error` may be downcast to `C` **or** to `E`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// That is, in codebases that rely on downcasting, Anyhow&#39;s context supports</span>
<span class="doccomment">/// both of the following use cases:</span>
<span class="doccomment">///</span>
<span class="doccomment">///   - **Attaching context whose type is insignificant onto errors whose type</span>
<span class="doccomment">///     is used in downcasts.**</span>
<span class="doccomment">///</span>
<span class="doccomment">///     In other error libraries whose context is not designed this way, it can</span>
<span class="doccomment">///     be risky to introduce context to existing code because new context might</span>
<span class="doccomment">///     break existing working downcasts. In Anyhow, any downcast that worked</span>
<span class="doccomment">///     before adding context will continue to work after you add a context, so</span>
<span class="doccomment">///     you should freely add human-readable context to errors wherever it would</span>
<span class="doccomment">///     be helpful.</span>
<span class="doccomment">///</span>
<span class="doccomment">///     ```</span>
<span class="doccomment">///     # use anyhow::bail;</span>
<span class="doccomment">///     # use thiserror::Error;</span>
<span class="doccomment">///     #</span>
<span class="doccomment">///     # #[derive(Error, Debug)]</span>
<span class="doccomment">///     # #[error(&quot;???&quot;)]</span>
<span class="doccomment">///     # struct SuspiciousError;</span>
<span class="doccomment">///     #</span>
<span class="doccomment">///     # fn helper() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">///     #     bail!(SuspiciousError);</span>
<span class="doccomment">///     # }</span>
<span class="doccomment">///     #</span>
<span class="doccomment">///     use anyhow::{Context, Result};</span>
<span class="doccomment">///</span>
<span class="doccomment">///     fn do_it() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">///         helper().context(&quot;Failed to complete the work&quot;)?;</span>
<span class="doccomment">///         # const IGNORE: &amp;str = stringify! {</span>
<span class="doccomment">///         ...</span>
<span class="doccomment">///         # };</span>
<span class="doccomment">///         # unreachable!()</span>
<span class="doccomment">///     }</span>
<span class="doccomment">///</span>
<span class="doccomment">///     fn main() {</span>
<span class="doccomment">///         let err = do_it().unwrap_err();</span>
<span class="doccomment">///         if let Some(e) = err.downcast_ref::&lt;SuspiciousError&gt;() {</span>
<span class="doccomment">///             // If helper() returned SuspiciousError, this downcast will</span>
<span class="doccomment">///             // correctly succeed even with the context in between.</span>
<span class="doccomment">///             # return;</span>
<span class="doccomment">///         }</span>
<span class="doccomment">///         # panic!(&quot;expected downcast to succeed&quot;);</span>
<span class="doccomment">///     }</span>
<span class="doccomment">///     ```</span>
<span class="doccomment">///</span>
<span class="doccomment">///   - **Attaching context whose type is used in downcasts onto errors whose</span>
<span class="doccomment">///     type is insignificant.**</span>
<span class="doccomment">///</span>
<span class="doccomment">///     Some codebases prefer to use machine-readable context to categorize</span>
<span class="doccomment">///     lower level errors in a way that will be actionable to higher levels of</span>
<span class="doccomment">///     the application.</span>
<span class="doccomment">///</span>
<span class="doccomment">///     ```</span>
<span class="doccomment">///     # use anyhow::bail;</span>
<span class="doccomment">///     # use thiserror::Error;</span>
<span class="doccomment">///     #</span>
<span class="doccomment">///     # #[derive(Error, Debug)]</span>
<span class="doccomment">///     # #[error(&quot;???&quot;)]</span>
<span class="doccomment">///     # struct HelperFailed;</span>
<span class="doccomment">///     #</span>
<span class="doccomment">///     # fn helper() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">///     #     bail!(&quot;no such file or directory&quot;);</span>
<span class="doccomment">///     # }</span>
<span class="doccomment">///     #</span>
<span class="doccomment">///     use anyhow::{Context, Result};</span>
<span class="doccomment">///</span>
<span class="doccomment">///     fn do_it() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">///         helper().context(HelperFailed)?;</span>
<span class="doccomment">///         # const IGNORE: &amp;str = stringify! {</span>
<span class="doccomment">///         ...</span>
<span class="doccomment">///         # };</span>
<span class="doccomment">///         # unreachable!()</span>
<span class="doccomment">///     }</span>
<span class="doccomment">///</span>
<span class="doccomment">///     fn main() {</span>
<span class="doccomment">///         let err = do_it().unwrap_err();</span>
<span class="doccomment">///         if let Some(e) = err.downcast_ref::&lt;HelperFailed&gt;() {</span>
<span class="doccomment">///             // If helper failed, this downcast will succeed because</span>
<span class="doccomment">///             // HelperFailed is the context that has been attached to</span>
<span class="doccomment">///             // that error.</span>
<span class="doccomment">///             # return;</span>
<span class="doccomment">///         }</span>
<span class="doccomment">///         # panic!(&quot;expected downcast to succeed&quot;);</span>
<span class="doccomment">///     }</span>
<span class="doccomment">///     ```</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Context</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">E</span><span class="op">&gt;</span>: <span class="ident">context::private::Sealed</span> {
    <span class="doccomment">/// Wrap the error value with additional context.</span>
    <span class="kw">fn</span> <span class="ident">context</span><span class="op">&lt;</span><span class="ident">C</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="ident">context</span>: <span class="ident">C</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">Error</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">C</span>: <span class="ident">Display</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span> <span class="op">+</span> <span class="lifetime">&#39;static</span>;

    <span class="doccomment">/// Wrap the error value with additional context that is evaluated lazily</span>
    <span class="doccomment">/// only once an error does occur.</span>
    <span class="kw">fn</span> <span class="ident">with_context</span><span class="op">&lt;</span><span class="ident">C</span>, <span class="ident">F</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="ident">f</span>: <span class="ident">F</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">Error</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">C</span>: <span class="ident">Display</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span> <span class="op">+</span> <span class="lifetime">&#39;static</span>,
        <span class="ident">F</span>: <span class="ident">FnOnce</span>() -&gt; <span class="ident">C</span>;
}

<span class="doccomment">/// Equivalent to Ok::&lt;_, anyhow::Error&gt;(value).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This simplifies creation of an anyhow::Result in places where type inference</span>
<span class="doccomment">/// cannot deduce the `E` type of the result &amp;mdash; without needing to write</span>
<span class="doccomment">/// `Ok::&lt;_, anyhow::Error&gt;(value)`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// One might think that `anyhow::Result::Ok(value)` would work in such cases</span>
<span class="doccomment">/// but it does not.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```console</span>
<span class="doccomment">/// error[E0282]: type annotations needed for `std::result::Result&lt;i32, E&gt;`</span>
<span class="doccomment">///   --&gt; src/main.rs:11:13</span>
<span class="doccomment">///    |</span>
<span class="doccomment">/// 11 |     let _ = anyhow::Result::Ok(1);</span>
<span class="doccomment">///    |         -   ^^^^^^^^^^^^^^^^^^ cannot infer type for type parameter `E` declared on the enum `Result`</span>
<span class="doccomment">///    |         |</span>
<span class="doccomment">///    |         consider giving this pattern the explicit type `std::result::Result&lt;i32, E&gt;`, where the type parameter `E` is specified</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">non_snake_case</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="prelude-val">Ok</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>(<span class="ident">t</span>: <span class="ident">T</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="ident">Result::Ok</span>(<span class="ident">t</span>)
}

<span class="comment">// Not public API. Referenced by macro-generated code.</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">private</span> {
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::Error</span>;
    <span class="kw">use</span> <span class="ident">alloc::fmt</span>;
    <span class="kw">use</span> <span class="ident">core::fmt::Arguments</span>;

    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::ensure</span>::{<span class="ident">BothDebug</span>, <span class="ident">NotBothDebug</span>};
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">alloc::format</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">core::result::Result::Err</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">core</span>::{<span class="ident">concat</span>, <span class="ident">format_args</span>, <span class="ident">stringify</span>};

    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">kind</span> {
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::kind</span>::{<span class="ident">AdhocKind</span>, <span class="ident">TraitKind</span>};

        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::kind::BoxedKind</span>;
    }

    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cold</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">format_err</span>(<span class="ident">args</span>: <span class="ident">Arguments</span>) -&gt; <span class="ident">Error</span> {
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">anyhow_no_fmt_arguments_as_str</span>)]</span>
        <span class="kw">let</span> <span class="ident">fmt_arguments_as_str</span> <span class="op">=</span> <span class="prelude-val">None</span>::<span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">&gt;</span>;
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">anyhow_no_fmt_arguments_as_str</span>))]</span>
        <span class="kw">let</span> <span class="ident">fmt_arguments_as_str</span> <span class="op">=</span> <span class="ident">args</span>.<span class="ident">as_str</span>();

        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">message</span>) <span class="op">=</span> <span class="ident">fmt_arguments_as_str</span> {
            <span class="comment">// anyhow!(&quot;literal&quot;), can downcast to &amp;&#39;static str</span>
            <span class="ident">Error::msg</span>(<span class="ident">message</span>)
        } <span class="kw">else</span> {
            <span class="comment">// anyhow!(&quot;interpolate {var}&quot;), can downcast to String</span>
            <span class="ident">Error::msg</span>(<span class="ident">fmt::format</span>(<span class="ident">args</span>))
        }
    }

    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cold</span>]</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">must_use</span>(<span class="ident">error</span>: <span class="ident">Error</span>) -&gt; <span class="ident">Error</span> {
        <span class="ident">error</span>
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="anyhow" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>